Index: rtld.c
===================================================================
RCS file: /home/ncvs/src/libexec/rtld-elf/rtld.c,v
retrieving revision 1.106.2.4
diff -u -r1.106.2.4 rtld.c
--- rtld.c	16 Jan 2007 07:51:04 -0000	1.106.2.4
+++ rtld.c	21 Jan 2007 03:40:48 -0000
@@ -133,6 +133,21 @@
 
 void r_debug_state(struct r_debug *, struct link_map *);
 
+extern int __dlclose(void *);
+extern int _dlclose(void *);
+extern const char *__dlerror(void);
+extern const char *_dlerror(void);
+extern void *__dlopen(const char *, int);
+extern void *_dlopen(const char *, int);
+extern void *__dlsym(void * __restrict, const char * __restrict);
+extern void *_dlsym(void * __restrict, const char * __restrict);
+extern int __dladdr(const void * __restrict, Dl_info * __restrict);
+extern int _dladdr(const void * __restrict, Dl_info * __restrict);
+extern void __dllockinit(void *, void *(*)(void *), void (*)(void *), void (*)(void *), void (*)(void *), void (*)(void *), void (*)(void *));
+extern void _dllockinit(void *, void *(*)(void *), void (*)(void *), void (*)(void *), void (*)(void *), void (*)(void *), void (*)(void *));
+extern int __dlinfo(void * __restrict, int, void * __restrict);
+extern int _dlinfo(void * __restrict, int, void * __restrict);
+
 /*
  * Data declarations.
  */
@@ -179,12 +194,26 @@
  */
 static func_ptr_type exports[] = {
     (func_ptr_type) &_rtld_error,
+    (func_ptr_type) &__dlclose,
+    (func_ptr_type) &_dlclose,
     (func_ptr_type) &dlclose,
+    (func_ptr_type) &__dlerror,
+    (func_ptr_type) &_dlerror,
     (func_ptr_type) &dlerror,
+    (func_ptr_type) &__dlopen,
+    (func_ptr_type) &_dlopen,
     (func_ptr_type) &dlopen,
+    (func_ptr_type) &__dlsym,
+    (func_ptr_type) &_dlsym,
     (func_ptr_type) &dlsym,
+    (func_ptr_type) &__dladdr,
+    (func_ptr_type) &_dladdr,
     (func_ptr_type) &dladdr,
+    (func_ptr_type) &__dllockinit,
+    (func_ptr_type) &_dllockinit,
     (func_ptr_type) &dllockinit,
+    (func_ptr_type) &__dlinfo,
+    (func_ptr_type) &_dlinfo,
     (func_ptr_type) &dlinfo,
     (func_ptr_type) &_rtld_thread_init,
 #ifdef __i386__
@@ -1621,7 +1650,7 @@
 }
 
 int
-dlclose(void *handle)
+__dlclose(void *handle)
 {
     Obj_Entry *root;
     int lockstate;
@@ -1656,20 +1685,24 @@
     wlock_release(rtld_bind_lock, lockstate);
     return 0;
 }
+__weak_reference(__dlclose, dlclose);
+__weak_reference(__dlclose, _dlclose);
 
 const char *
-dlerror(void)
+__dlerror(void)
 {
     char *msg = error_message;
     error_message = NULL;
     return msg;
 }
+__weak_reference(__dlerror, dlerror);
+__weak_reference(__dlerror, _dlerror);
 
 /*
  * This function is deprecated and has no effect.
  */
 void
-dllockinit(void *context,
+__dllockinit(void *context,
 	   void *(*lock_create)(void *context),
            void (*rlock_acquire)(void *lock),
            void (*wlock_acquire)(void *lock),
@@ -1686,9 +1719,11 @@
     cur_context = context;
     cur_context_destroy = context_destroy;
 }
+__weak_reference(__dllockinit, dllockinit);
+__weak_reference(__dllockinit, _dllockinit);
 
 void *
-dlopen(const char *name, int mode)
+__dlopen(const char *name, int mode)
 {
     Obj_Entry **old_obj_tail;
     Obj_Entry *obj;
@@ -1763,9 +1798,11 @@
     wlock_release(rtld_bind_lock, lockstate);
     exit(0);
 }
+__weak_reference(__dlopen, dlopen);
+__weak_reference(__dlopen, _dlopen);
 
 void *
-dlsym(void *handle, const char *name)
+__dlsym(void *handle, const char *name)
 {
     DoneList donelist;
     const Obj_Entry *obj, *defobj;
@@ -1849,9 +1886,11 @@
     rlock_release(rtld_bind_lock, lockstate);
     return NULL;
 }
+__weak_reference(__dlsym, dlsym);
+__weak_reference(__dlsym, _dlsym);
 
 int
-dladdr(const void *addr, Dl_info *info)
+__dladdr(const void *addr, Dl_info *info)
 {
     const Obj_Entry *obj;
     const Elf_Sym *def;
@@ -1905,9 +1944,11 @@
     rlock_release(rtld_bind_lock, lockstate);
     return 1;
 }
+__weak_reference(__dladdr, dladdr);
+__weak_reference(__dladdr, _dladdr);
 
 int
-dlinfo(void *handle, int request, void *p)
+__dlinfo(void *handle, int request, void *p)
 {
     const Obj_Entry *obj;
     int error, lockstate;
@@ -1951,6 +1992,8 @@
 
     return (error);
 }
+__weak_reference(__dlinfo, dlinfo);
+__weak_reference(__dlinfo, _dlinfo);
 
 struct fill_search_info_args {
     int		 request;
@@ -2877,3 +2920,10 @@
     free_tls(tcb, tcbsize, tcbalign);
     wlock_release(rtld_bind_lock, lockstate);
 }
+
+
+
+
+
+
+
